Index: src/api/api_lib.c
===================================================================
RCS file: /sources/lwip/lwip/src/api/api_lib.c,v
retrieving revision 1.37
diff -w -b -u -3 -p -r1.37 api_lib.c
--- src/api/api_lib.c	10 May 2007 05:20:05 -0000	1.37
+++ src/api/api_lib.c	10 May 2007 15:05:34 -0000
@@ -37,6 +37,7 @@
 #include "lwip/opt.h"
 #include "lwip/api.h"
 #include "lwip/api_msg.h"
+#include "lwip/tcpip.h"
 #include "lwip/memp.h"
 
 
@@ -215,10 +216,10 @@ netconn *netconn_new_with_proto_and_call
   conn->recv_timeout = 0;
 #endif /* LWIP_SO_RCVTIMEO */
 
-  msg.type = API_MSG_NEWCONN;
+  msg.function = do_newconn;
   msg.msg.msg.bc.port = proto; /* misusing the port field */
   msg.msg.conn = conn;
-  api_msg_post(&msg);  
+  tcpip_apimsg(&msg);  
 
   if ( conn->err != ERR_OK ) {
     sys_sem_free(conn->sem);
@@ -253,9 +254,9 @@ netconn_delete(struct netconn *conn)
     return ERR_OK;
   }
   
-  msg.type = API_MSG_DELCONN;
+  msg.function = do_delconn;
   msg.msg.conn = conn;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
 
   /* Drain the recvmbox. */
   if (conn->recvmbox != SYS_MBOX_NULL) {
@@ -363,11 +364,11 @@ netconn_bind(struct netconn *conn, struc
     }
   }
   
-  msg.type = API_MSG_BIND;
+  msg.function = do_bind;
   msg.msg.conn = conn;
   msg.msg.msg.bc.ipaddr = addr;
   msg.msg.msg.bc.port = port;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return conn->err;
 }
 
@@ -387,11 +388,11 @@ netconn_connect(struct netconn *conn, st
     }
   }
   
-  msg.type = API_MSG_CONNECT;
+  msg.function = do_connect;
   msg.msg.conn = conn;  
   msg.msg.msg.bc.ipaddr = addr;
   msg.msg.msg.bc.port = port;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return conn->err;
 }
 
@@ -404,9 +405,9 @@ netconn_disconnect(struct netconn *conn)
     return ERR_VAL;
   }
 
-  msg.type = API_MSG_DISCONNECT;
+  msg.function = do_disconnect;
   msg.msg.conn = conn;  
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return conn->err;
 
 }
@@ -426,9 +427,9 @@ netconn_listen(struct netconn *conn)
     }
   }
   
-  msg.type = API_MSG_LISTEN;
+  msg.function = do_listen;
   msg.msg.conn = conn;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return conn->err;
 }
 
@@ -514,14 +515,14 @@ netconn_recv(struct netconn *conn)
     buf->addr = NULL;
 
     /* Let the stack know that we have taken the data. */
-    msg.type = API_MSG_RECV;
+    msg.function = do_recv;
     msg.msg.conn = conn;
     if (buf != NULL) {
       msg.msg.msg.len = buf->p->tot_len;
     } else {
       msg.msg.msg.len = 1;
     }
-    api_msg_post(&msg);
+    tcpip_apimsg(&msg);
   } else {
 #if LWIP_SO_RCVTIMEO
     sys_mbox_fetch_timeout(conn->recvmbox, (void *)&buf, conn->recv_timeout);
@@ -565,10 +566,10 @@ netconn_send(struct netconn *conn, struc
   }
 
   LWIP_DEBUGF(API_LIB_DEBUG, ("netconn_send: sending %d bytes\n", buf->p->tot_len));
-  msg.type = API_MSG_SEND;
+  msg.function = do_send;
   msg.msg.conn = conn;
   msg.msg.msg.b = buf;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return conn->err;
 }
 
@@ -586,7 +587,7 @@ netconn_write(struct netconn *conn, cons
     return conn->err;
   }
 
-  msg.type = API_MSG_WRITE;
+  msg.function = do_write;
   msg.msg.conn = conn;
 
   conn->state = NETCONN_WRITE;
@@ -613,7 +614,7 @@ netconn_write(struct netconn *conn, cons
     
     LWIP_DEBUGF(API_LIB_DEBUG, ("netconn_write: writing %d bytes (%d)\n", len, copy));
     msg.msg.msg.w.len = len;
-    api_msg_post(&msg);
+    tcpip_apimsg(&msg);
     if (conn->err == ERR_OK) {
       dataptr = (void *)((u8_t *)dataptr + len);
       size -= len;
@@ -641,9 +642,9 @@ netconn_close(struct netconn *conn)
 
   conn->state = NETCONN_CLOSE;
  again:
-  msg.type = API_MSG_CLOSE;
+  msg.function = do_close;
   msg.msg.conn = conn;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   if (conn->err == ERR_MEM && conn->sem != SYS_SEM_NULL) {
     sys_sem_wait(conn->sem);
     goto again;
@@ -673,11 +674,11 @@ netconn_join_leave_group (struct netconn
   ipaddr[0] = multiaddr;
   ipaddr[1] = interface;
 
-  msg.type = API_MSG_JOIN_LEAVE;
+  msg.function = do_join_leave_group;
   msg.msg.conn = conn;
   msg.msg.msg.bc.ipaddr = (struct ip_addr *)ipaddr;
   msg.msg.msg.bc.port = join_or_leave;
-  api_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return conn->err;
 }
 #endif /* LWIP_IGMP */


Index: src/api/api_msg.c
===================================================================
RCS file: /sources/lwip/lwip/src/api/api_msg.c,v
retrieving revision 1.35
diff -w -b -u -3 -p -r1.35 api_msg.c
--- src/api/api_msg.c	4 May 2007 15:18:30 -0000	1.35
+++ src/api/api_msg.c	10 May 2007 15:03:30 -0000
@@ -342,7 +342,7 @@ pcb_new(struct api_msg_msg *msg)
   return msg->conn->err;
 }
 
-static void
+void
 do_newconn(struct api_msg_msg *msg)
 {
    if(msg->conn->pcb.tcp == NULL) {
@@ -355,7 +355,7 @@ do_newconn(struct api_msg_msg *msg)
    sys_mbox_post(msg->conn->mbox, NULL);
 }
 
-static void
+void
 do_delconn(struct api_msg_msg *msg)
 {
   if (msg->conn->pcb.tcp != NULL) {
@@ -407,7 +407,7 @@ do_delconn(struct api_msg_msg *msg)
   }
 }
 
-static void
+void
 do_bind(struct api_msg_msg *msg)
 {
   if (msg->conn->pcb.tcp == NULL) {
@@ -465,7 +465,7 @@ do_connected(void *arg, struct tcp_pcb *
 }
 #endif /* LWIP_TCP */
 
-static void
+void
 do_connect(struct api_msg_msg *msg)
 {
   if (msg->conn->pcb.tcp == NULL) {
@@ -505,7 +505,7 @@ do_connect(struct api_msg_msg *msg)
   }
 }
 
-static void
+void
 do_disconnect(struct api_msg_msg *msg)
 {
   switch (msg->conn->type) {
@@ -530,7 +530,7 @@ do_disconnect(struct api_msg_msg *msg)
 }
 
 
-static void
+void
 do_listen(struct api_msg_msg *msg)
 {
   if (msg->conn->pcb.tcp != NULL) {
@@ -572,7 +572,7 @@ do_listen(struct api_msg_msg *msg)
   sys_mbox_post(msg->conn->mbox, NULL);
 }
 
-static void
+void
 do_send(struct api_msg_msg *msg)
 {
 
@@ -609,7 +609,7 @@ do_send(struct api_msg_msg *msg)
   sys_mbox_post(msg->conn->mbox, NULL);
 }
 
-static void
+void
 do_recv(struct api_msg_msg *msg)
 {
 #if LWIP_TCP
@@ -622,7 +622,7 @@ do_recv(struct api_msg_msg *msg)
   sys_mbox_post(msg->conn->mbox, NULL);
 }
 
-static void
+void
 do_write(struct api_msg_msg *msg)
 {
 #if LWIP_TCP  
@@ -673,7 +673,7 @@ do_write(struct api_msg_msg *msg)
   sys_mbox_post(msg->conn->mbox, NULL);
 }
 
-static void
+void
 do_close(struct api_msg_msg *msg)
 {
   err_t err;
@@ -711,7 +711,7 @@ do_close(struct api_msg_msg *msg)
 }
  
 #if LWIP_IGMP
-static void
+void
 do_join_leave_group(struct api_msg_msg *msg)
 {
   err_t err = ERR_OK;
@@ -746,34 +746,3 @@ do_join_leave_group(struct api_msg_msg *
   sys_mbox_post(msg->conn->mbox, NULL);
 }
 #endif /* LWIP_IGMP */
-
-typedef void (* api_msg_decode)(struct api_msg_msg *msg);
-static api_msg_decode decode[API_MSG_MAX] = {
-  do_newconn,
-  do_delconn,
-  do_bind,
-  do_connect,
-  do_disconnect,
-  do_listen,
-  do_send,
-  do_recv,
-  do_write,
-  do_close,
-#if LWIP_IGMP
-  do_join_leave_group
-#endif /* LWIP_IGMP */
-};
-
-void
-api_msg_input(struct api_msg *msg)
-{ struct api_msg_msg msg_copy;
-  msg_copy=msg->msg;
-  decode[msg->type](&msg_copy);
-}
-
-err_t
-api_msg_post(struct api_msg *msg)
-{
-  return tcpip_apimsg(msg);
-}
-


Index: src/api/netifapi.c
===================================================================
RCS file: /sources/lwip/lwip/src/api/netifapi.c,v
retrieving revision 1.1
diff -w -b -u -3 -p -r1.1 netifapi.c
--- src/api/netifapi.c	6 Apr 2007 10:09:24 -0000	1.1
+++ src/api/netifapi.c	10 May 2007 15:06:15 -0000
@@ -49,7 +49,7 @@ netifapi_netif_add( struct netif *netif,
   msg.msg.add.state   = state;
   msg.msg.add.init    = init;
   msg.msg.add.input   = input;
-  netifapi_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return msg.err;
 }
 
@@ -58,7 +58,7 @@ netifapi_netif_remove( struct netif *net
 { struct netifapi_msg msg;
   msg.type  = NETIFAPI_MSG_NETIF_REMOVE;
   msg.netif = netif;  
-  netifapi_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return msg.err;
 }
 
@@ -67,7 +67,7 @@ netifapi_dhcp_start( struct netif *netif
 { struct netifapi_msg msg;
   msg.type  = NETIFAPI_MSG_DHCP_START;
   msg.netif = netif;  
-  netifapi_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return msg.err;
 }
 
@@ -76,7 +76,7 @@ netifapi_dhcp_stop( struct netif *netif)
 { struct netifapi_msg msg;
   msg.type  = NETIFAPI_MSG_DHCP_STOP;
   msg.netif = netif;  
-  netifapi_msg_post(&msg);
+  tcpip_apimsg(&msg);
   return msg.err;
 }
 
@@ -110,9 +110,4 @@ netifapi_msg_input( struct netifapi_msg 
  sys_sem_signal(msg->sem);
 }
 
-err_t
-netifapi_msg_post( struct netifapi_msg *msg)
-{ return tcpip_netifapi(msg);
-}
-
 #endif /* LWIP_NETIF_API */


Index: src/api/tcpip.c
===================================================================
RCS file: /sources/lwip/lwip/src/api/tcpip.c,v
retrieving revision 1.35
diff -w -b -u -3 -p -r1.35 tcpip.c
--- src/api/tcpip.c	24 Apr 2007 08:35:19 -0000	1.35
+++ src/api/tcpip.c	10 May 2007 15:02:27 -0000
@@ -196,7 +196,7 @@ tcpip_thread(void *arg)
     switch (msg->type) {
     case TCPIP_MSG_API:
       LWIP_DEBUGF(TCPIP_DEBUG, ("tcpip_thread: API message %p\n", (void *)msg));
-      api_msg_input(msg->msg.apimsg);
+      msg->msg.apimsg->function(&(msg->msg.apimsg->msg));
       break;
 
 #if ETHARP_TCPIP_INPUT      


Index: src/include/lwip/api_msg.h
===================================================================
RCS file: /sources/lwip/lwip/src/include/lwip/api_msg.h,v
retrieving revision 1.11
diff -w -b -u -3 -p -r1.11 api_msg.h
--- src/include/lwip/api_msg.h	10 May 2007 10:59:20 -0000	1.11
+++ src/include/lwip/api_msg.h	10 May 2007 15:02:10 -0000
@@ -47,29 +47,6 @@
 extern "C" {
 #endif
 
-enum api_msg_type {
-  API_MSG_NEWCONN,
-  API_MSG_DELCONN,
-  
-  API_MSG_BIND,
-  API_MSG_CONNECT,
-  API_MSG_DISCONNECT,
-
-  API_MSG_LISTEN,
-
-  API_MSG_SEND,
-  API_MSG_RECV,
-  API_MSG_WRITE,
-
-  API_MSG_CLOSE,
-
-#if LWIP_IGMP
-  API_MSG_JOIN_LEAVE,
-#endif /* LWIP_IGMP */
- 
-  API_MSG_MAX
-};
-
 struct api_msg_msg {
   struct netconn *conn;
   enum netconn_type conntype;
@@ -91,12 +68,23 @@ struct api_msg_msg {
 };
 
 struct api_msg {
-  enum api_msg_type type;
+  void (* function)(struct api_msg_msg *msg);
   struct api_msg_msg msg;
 };
 
-void  api_msg_input(struct api_msg *msg);
-err_t api_msg_post(struct api_msg *msg);
+extern void do_newconn         ( struct api_msg_msg *msg);
+extern void do_delconn         ( struct api_msg_msg *msg);
+extern void do_bind            ( struct api_msg_msg *msg);
+extern void do_connect         ( struct api_msg_msg *msg);
+extern void do_disconnect      ( struct api_msg_msg *msg);
+extern void do_listen          ( struct api_msg_msg *msg);
+extern void do_send            ( struct api_msg_msg *msg);
+extern void do_recv            ( struct api_msg_msg *msg);
+extern void do_write           ( struct api_msg_msg *msg);
+extern void do_close           ( struct api_msg_msg *msg);
+#if LWIP_IGMP
+extern void do_join_leave_group( struct api_msg_msg *msg);
+#endif /* LWIP_IGMP */
 
 #ifdef __cplusplus
 }


Index: src/include/lwip/netifapi.h
===================================================================
RCS file: /sources/lwip/lwip/src/include/lwip/netifapi.h,v
retrieving revision 1.2
diff -w -b -u -3 -p -r1.2 netifapi.h
--- src/include/lwip/netifapi.h	10 May 2007 10:59:20 -0000	1.2
+++ src/include/lwip/netifapi.h	10 May 2007 15:06:37 -0000
@@ -84,7 +84,6 @@ err_t netifapi_dhcp_stop   ( struct neti
 
 /* API for tcpip_thread */
 void  netifapi_msg_input(struct netifapi_msg *msg);
-err_t netifapi_msg_post (struct netifapi_msg *msg);
 
 #ifdef __cplusplus
 }