? avr-libc/include/avr/iousb1286.h
? avr-libc/include/avr/iousb1287.h
? avr-libc/include/avr/iousb646.h
? avr-libc/include/avr/iousb647.h
? avr-libc/include/avr/iousbxx6_7.h
Index: avr-libc/NEWS
===================================================================
RCS file: /sources/avr-libc/avr-libc/NEWS,v
retrieving revision 1.144
diff -u -r1.144 NEWS
--- avr-libc/NEWS	2 Feb 2006 19:37:16 -0000	1.144
+++ avr-libc/NEWS	28 Feb 2006 17:32:10 -0000
@@ -54,6 +54,10 @@
   + ATtiny84
   + ATtiny861
   + ATmega406
+  + AT90USB646
+  + AT90USB647
+  + AT90USB1286
+  + AT90USB1287
   
 * New functions: 
 
Index: avr-libc/configure.ac
===================================================================
RCS file: /sources/avr-libc/avr-libc/configure.ac,v
retrieving revision 1.28
diff -u -r1.28 configure.ac
--- avr-libc/configure.ac	30 Jan 2006 21:31:17 -0000	1.28
+++ avr-libc/configure.ac	28 Feb 2006 17:32:10 -0000
@@ -519,6 +519,18 @@
 CHECK_AVR_DEVICE(at90can128)
 AM_CONDITIONAL(HAS_at90can128, test "x$HAS_at90can128" = "xyes")
 
+CHECK_AVR_DEVICE(at90usb646)
+AM_CONDITIONAL(HAS_at90usb646, test "x$HAS_at90usb646" = "xyes")
+
+CHECK_AVR_DEVICE(at90usb647)
+AM_CONDITIONAL(HAS_at90usb647, test "x$HAS_at90usb647" = "xyes")
+
+CHECK_AVR_DEVICE(at90usb1286)
+AM_CONDITIONAL(HAS_at90usb1286, test "x$HAS_at90usb1286" = "xyes")
+
+CHECK_AVR_DEVICE(at90usb1287)
+AM_CONDITIONAL(HAS_at90usb1287, test "x$HAS_at90usb1287" = "xyes")
+
 # Generate all files from *.in sources.
 
 AC_CONFIG_FILES([
@@ -633,6 +645,10 @@
 	avr/lib/avr5/at90can32/Makefile
 	avr/lib/avr5/at90can64/Makefile
 	avr/lib/avr5/at90can128/Makefile
+	avr/lib/avr5/at90usb646/Makefile
+	avr/lib/avr5/at90usb647/Makefile
+	avr/lib/avr5/at90usb1286/Makefile
+	avr/lib/avr5/at90usb1287/Makefile
 	avr/lib/avr5/at94k/Makefile
 ])
 
Index: avr-libc/devtools/gen-avr-lib-tree.sh
===================================================================
RCS file: /sources/avr-libc/avr-libc/devtools/gen-avr-lib-tree.sh,v
retrieving revision 1.15
diff -u -r1.15 gen-avr-lib-tree.sh
--- avr-libc/devtools/gen-avr-lib-tree.sh	30 Jan 2006 21:31:17 -0000	1.15
+++ avr-libc/devtools/gen-avr-lib-tree.sh	28 Feb 2006 17:32:10 -0000
@@ -203,6 +203,10 @@
 at90can32:crtcan32.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 at90can64:crtcan64.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 at90can128:crtcan128.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+at90usb646:crtusb646.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+at90usb647:crtusb647.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+at90usb1286:crtusb1286.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+at90usb1287:crtusb1287.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 at94k:crtat94k.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS}\
 "
 
Index: avr-libc/doc/api/main_page.dox
===================================================================
RCS file: /sources/avr-libc/avr-libc/doc/api/main_page.dox,v
retrieving revision 1.31
diff -u -r1.31 main_page.dox
--- avr-libc/doc/api/main_page.dox	30 Jan 2006 21:31:17 -0000	1.31
+++ avr-libc/doc/api/main_page.dox	28 Feb 2006 17:32:10 -0000
@@ -167,6 +167,10 @@
 - at90can128
 - at90pwm2
 - at90pwm3
+- at90usb646
+- at90usb647
+- at90usb1286
+- at90usb1287
 
 \anchor supp_dev_footnote_one
 
Index: avr-libc/doc/api/using-tools.dox
===================================================================
RCS file: /sources/avr-libc/avr-libc/doc/api/using-tools.dox,v
retrieving revision 1.16
diff -u -r1.16 using-tools.dox
--- avr-libc/doc/api/using-tools.dox	30 Jan 2006 21:31:17 -0000	1.16
+++ avr-libc/doc/api/using-tools.dox	28 Feb 2006 17:32:10 -0000
@@ -117,6 +117,10 @@
   <tr><td>avr5</td><td>at90can32</td><td>__AVR_AT90CAN32__</td></tr>
   <tr><td>avr5</td><td>at90can64</td><td>__AVR_AT90CAN64__</td></tr>
   <tr><td>avr5</td><td>at90can128</td><td>__AVR_AT90CAN128__</td></tr>
+  <tr><td>avr5</td><td>at90usb646</td><td>__AVR_AT90USB646__</td></tr>
+  <tr><td>avr5</td><td>at90usb647</td><td>__AVR_AT90USB647__</td></tr>
+  <tr><td>avr5</td><td>at90usb1286</td><td>__AVR_AT90USB1286__</td></tr>
+  <tr><td>avr5</td><td>at90usb1287</td><td>__AVR_AT90USB1287__</td></tr>
   <tr><td>avr5</td><td>atmega128</td><td>__AVR_ATmega128__</td></tr>
   <tr><td>avr5</td><td>atmega1280</td><td>__AVR_ATmega1280__</td></tr>
   <tr><td>avr5</td><td>atmega1281</td><td>__AVR_ATmega1281__</td></tr>
Index: avr-libc/include/avr/Makefile.am
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/Makefile.am,v
retrieving revision 1.13
diff -u -r1.13 Makefile.am
--- avr-libc/include/avr/Makefile.am	30 Jan 2006 21:31:17 -0000	1.13
+++ avr-libc/include/avr/Makefile.am	28 Feb 2006 17:32:11 -0000
@@ -57,6 +57,11 @@
     iocan64.h \
     iocan128.h \
     iocanxx.h \
+    iousb646.h \
+    iousb647.h \
+    iousb1286.h \
+    iousb1287.h \
+    iousbxx6_7.h \
     iom103.h \
     iom128.h \
     iom1280.h \
Index: avr-libc/include/avr/io.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io.h,v
retrieving revision 1.29
diff -u -r1.29 io.h
--- avr-libc/include/avr/io.h	28 Feb 2006 16:47:16 -0000	1.29
+++ avr-libc/include/avr/io.h	28 Feb 2006 17:32:11 -0000
@@ -194,6 +194,14 @@
 #  include <avr/iocan64.h>
 #elif defined (__AVR_AT90CAN128__)
 #  include <avr/iocan128.h>
+#elif defined (__AVR_AT90USB646__)
+#  include <avr/iousb646.h>
+#elif defined (__AVR_AT90USB647__)
+#  include <avr/iousb647.h>
+#elif defined (__AVR_AT90USB1286__)
+#  include <avr/iousb1286.h>
+#elif defined (__AVR_AT90USB1287__)
+#  include <avr/iousb1287.h>
 #elif defined (__AVR_ATmega64__)
 #  include <avr/iom64.h>
 #elif defined (__AVR_ATmega640__)
Index: avr-libc/include/avr/wdt.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/wdt.h,v
retrieving revision 1.25
diff -u -r1.25 wdt.h
--- avr-libc/include/avr/wdt.h	30 Jan 2006 21:31:17 -0000	1.25
+++ avr-libc/include/avr/wdt.h	28 Feb 2006 17:32:11 -0000
@@ -117,6 +117,8 @@
 
 #if defined (__AVR_ATmega169__) || defined(__AVR_AT90CAN128__) \
 || defined(__AVR_AT90CAN32__) || defined(__AVR_AT90CAN64__) \
+|| defined(__AVR_AT90USB646__) || defined(__AVR_AT90USB647__) \
+|| defined(__AVR_AT90USB1286__) || defined(__AVR_AT90USB1287__) \
 || defined(__AVR_ATmega48__) || defined(__AVR_ATmega88__) \
 || defined(__AVR_ATmega164__) \
 || defined(__AVR_ATmega165__) || defined(__AVR_ATmega168__) \