Index: avr-libc/configure.ac
===================================================================
RCS file: /sources/avr-libc/avr-libc/configure.ac,v
retrieving revision 1.37
diff -u -r1.37 configure.ac
--- avr-libc/configure.ac	14 Jan 2007 20:17:34 -0000	1.37
+++ avr-libc/configure.ac	28 Jan 2007 16:29:44 -0000
@@ -477,12 +477,21 @@
 CHECK_AVR_DEVICE(atmega325)
 AM_CONDITIONAL(HAS_atmega325, test "x$HAS_atmega325" = "xyes")
 
+CHECK_AVR_DEVICE(atmega325p)
+AM_CONDITIONAL(HAS_atmega325p, test "x$HAS_atmega325p" = "xyes")
+
 CHECK_AVR_DEVICE(atmega3250)
 AM_CONDITIONAL(HAS_atmega3250, test "x$HAS_atmega3250" = "xyes")
 
+CHECK_AVR_DEVICE(atmega3250p)
+AM_CONDITIONAL(HAS_atmega3250p, test "x$HAS_atmega3250p" = "xyes")
+
 CHECK_AVR_DEVICE(atmega329)
 AM_CONDITIONAL(HAS_atmega329, test "x$HAS_atmega329" = "xyes")
 
+CHECK_AVR_DEVICE(atmega329p)
+AM_CONDITIONAL(HAS_atmega329p, test "x$HAS_atmega329p" = "xyes")
+
 CHECK_AVR_DEVICE(atmega3290)
 AM_CONDITIONAL(HAS_atmega3290, test "x$HAS_atmega3290" = "xyes")
 
@@ -651,8 +660,11 @@
 	avr/lib/avr5/atmega323/Makefile
 	avr/lib/avr5/atmega324p/Makefile
 	avr/lib/avr5/atmega325/Makefile
+	avr/lib/avr5/atmega325p/Makefile
 	avr/lib/avr5/atmega3250/Makefile
+	avr/lib/avr5/atmega3250p/Makefile
 	avr/lib/avr5/atmega329/Makefile
+	avr/lib/avr5/atmega329p/Makefile
 	avr/lib/avr5/atmega3290/Makefile
 	avr/lib/avr5/atmega3290p/Makefile
 	avr/lib/avr5/atmega406/Makefile
Index: avr-libc/devtools/gen-avr-lib-tree.sh
===================================================================
RCS file: /sources/avr-libc/avr-libc/devtools/gen-avr-lib-tree.sh,v
retrieving revision 1.22
diff -u -r1.22 gen-avr-lib-tree.sh
--- avr-libc/devtools/gen-avr-lib-tree.sh	14 Jan 2007 20:17:34 -0000	1.22
+++ avr-libc/devtools/gen-avr-lib-tree.sh	28 Jan 2007 16:29:44 -0000
@@ -189,8 +189,11 @@
 atmega323:crtm323.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega324p:crtm324p.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega325:crtm325.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+atmega325p:crtm325p.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega3250:crtm3250.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+atmega3250p:crtm3250p.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega329:crtm329.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
+atmega329p:crtm329p.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega3290:crtm3290.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega3290p:crtm3290p.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
 atmega406:crtm406.o:${DEV_DEFS}:${CFLAGS_SPEED}:${DEV_ASFLAGS};\
Index: avr-libc/doc/api/main_page.dox
===================================================================
RCS file: /sources/avr-libc/avr-libc/doc/api/main_page.dox,v
retrieving revision 1.39
diff -u -r1.39 main_page.dox
--- avr-libc/doc/api/main_page.dox	22 Jan 2007 23:21:06 -0000	1.39
+++ avr-libc/doc/api/main_page.dox	28 Jan 2007 16:29:44 -0000
@@ -123,8 +123,11 @@
 - atmega323
 - atmega324p
 - atmega325
+- atmega325p
 - atmega3250
+- atmega3250p
 - atmega329
+- atmega329p
 - atmega3290
 - atmega3290p
 - atmega48
Index: avr-libc/doc/api/using-tools.dox
===================================================================
RCS file: /sources/avr-libc/avr-libc/doc/api/using-tools.dox,v
retrieving revision 1.23
diff -u -r1.23 using-tools.dox
--- avr-libc/doc/api/using-tools.dox	14 Jan 2007 20:17:34 -0000	1.23
+++ avr-libc/doc/api/using-tools.dox	28 Jan 2007 16:29:44 -0000
@@ -140,8 +140,11 @@
   <tr><td>avr5</td><td>atmega323</td><td>__AVR_ATmega323__</td></tr>
   <tr><td>avr5</td><td>atmega324p</td><td>__AVR_ATmega324P__</td></tr>
   <tr><td>avr5</td><td>atmega325</td><td>__AVR_ATmega325__</td></tr>
+  <tr><td>avr5</td><td>atmega325p</td><td>__AVR_ATmega325P__</td></tr>
   <tr><td>avr5</td><td>atmega3250</td><td>__AVR_ATmega3250__</td></tr>
+  <tr><td>avr5</td><td>atmega3250p</td><td>__AVR_ATmega3250P__</td></tr>
   <tr><td>avr5</td><td>atmega329</td><td>__AVR_ATmega329__</td></tr>
+  <tr><td>avr5</td><td>atmega329p</td><td>__AVR_ATmega329P__</td></tr>
   <tr><td>avr5</td><td>atmega3290</td><td>__AVR_ATmega3290__</td></tr>
   <tr><td>avr5</td><td>atmega3290p</td><td>__AVR_ATmega3290P__</td></tr>
   <tr><td>avr5</td><td>atmega406</td><td>__AVR_ATmega406__</td></tr>
Index: avr-libc/include/avr/io.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io.h,v
retrieving revision 1.39
diff -u -r1.39 io.h
--- avr-libc/include/avr/io.h	27 Jan 2007 21:05:06 -0000	1.39
+++ avr-libc/include/avr/io.h	28 Jan 2007 16:29:44 -0000
@@ -240,10 +240,16 @@
 #  include <avr/iom324.h>
 #elif defined (__AVR_ATmega325__)
 #  include <avr/iom325.h>
+#elif defined (__AVR_ATmega325P__)
+#  include <avr/iom325.h>
 #elif defined (__AVR_ATmega3250__)
 #  include <avr/iom3250.h>
+#elif defined (__AVR_ATmega3250P__)
+#  include <avr/iom3250.h>
 #elif defined (__AVR_ATmega329__)
 #  include <avr/iom329.h>
+#elif defined (__AVR_ATmega329P__)
+#  include <avr/iom329.h>
 #elif defined (__AVR_ATmega3290__)
 #  include <avr/iom3290.h>
 #elif defined (__AVR_ATmega3290P__)
Index: avr-libc/include/avr/iom325.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom325.h,v
retrieving revision 1.10
diff -u -r1.10 iom325.h
--- avr-libc/include/avr/iom325.h	14 Mar 2006 20:57:40 -0000	1.10
+++ avr-libc/include/avr/iom325.h	28 Jan 2007 16:29:44 -0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2004,2005,2006 Eric B. Weddington
+/* Copyright (c) 2004, 2005, 2006, 2007 Eric B. Weddington
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -30,7 +30,7 @@
 
 /* $Id: iom325.h,v 1.10 2006/03/14 20:57:40 aesok Exp $ */
 
-/* avr/iom325.h - definitions for ATmega325 */
+/* avr/iom325.h - definitions for ATmega325 and ATmega325P.  */
 
 #ifndef _AVR_IOM325_H_
 #define _AVR_IOM325_H_ 1
@@ -387,6 +387,10 @@
 #define IVCE    0
 #define IVSEL   1
 #define PUD     4
+#if defined(__AVR_ATmega325P__)
+#define BODSE   5
+#define BODS    6
+#endif
 #define JTD     7
 
 /* Reserved [0x36] */
Index: avr-libc/include/avr/iom3250.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom3250.h,v
retrieving revision 1.10
diff -u -r1.10 iom3250.h
--- avr-libc/include/avr/iom3250.h	14 Mar 2006 20:57:40 -0000	1.10
+++ avr-libc/include/avr/iom3250.h	28 Jan 2007 16:29:44 -0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2004,2005,2006 Eric B. Weddington
+/* Copyright (c) 2004, 2005, 2006, 2007 Eric B. Weddington
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -30,7 +30,7 @@
 
 /* $Id: iom3250.h,v 1.10 2006/03/14 20:57:40 aesok Exp $ */
 
-/* avr/iom3250.h - definitions for ATmega3250 */
+/* avr/iom3250.h - definitions for ATmega3250 and ATmega3250P.  */
 
 #ifndef _AVR_IOM3250_H_
 #define _AVR_IOM3250_H_ 1
@@ -390,6 +390,10 @@
 #define IVCE    0
 #define IVSEL   1
 #define PUD     4
+#if defined(__AVR_ATmega3250P__)
+#define BODSE   5
+#define BODS    6
+#endif
 #define JTD     7
 
 /* Reserved [0x36] */
Index: avr-libc/include/avr/iom329.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom329.h,v
retrieving revision 1.6
diff -u -r1.6 iom329.h
--- avr-libc/include/avr/iom329.h	14 Mar 2006 20:57:40 -0000	1.6
+++ avr-libc/include/avr/iom329.h	28 Jan 2007 16:29:44 -0000
@@ -1,5 +1,5 @@
 /* Copyright (c) 2004 Eric B. Weddington
-   Copyright (c) 2005,2006 Anatoly Sokolov 
+   Copyright (c) 2005, 2006, 2007 Anatoly Sokolov 
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -29,7 +29,7 @@
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE. */
 
-/* avr/iom329.h - definitions for ATmega329 */
+/* avr/iom329.h - definitions for ATmega329 and ATmega329P.  */
 
 #ifndef _AVR_IOM329_H_
 #define _AVR_IOM329_H_ 1
@@ -385,6 +385,10 @@
 #define IVCE    0
 #define IVSEL   1
 #define PUD     4
+#if defined(__AVR_ATmega329P__)
+#define BODSE   5
+#define BODS    6
+#endif
 #define JTD     7
 
 /* Reserved [0x36] */
@@ -669,6 +673,10 @@
 
 #define LCDCRA  _SFR_MEM8(0XE4)
 #define LCDBL   0
+#if defined(__AVR_ATmega329P__)
+#define LCDCCD  1
+#define LCDBD   2
+#endif
 #define LCDIE   3
 #define LCDIF   4
 #define LCDAB   6
@@ -696,6 +704,9 @@
 #define LCDCC1  1
 #define LCDCC2  2
 #define LCDCC3  3
+#if defined(__AVR_ATmega329P__)
+#define LCDMDT  4
+#endif
 #define LCDDC0  5
 #define LCDDC1  6
 #define LCDDC2  7
Index: avr-libc/include/avr/wdt.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/wdt.h,v
retrieving revision 1.34
diff -u -r1.34 wdt.h
--- avr-libc/include/avr/wdt.h	23 Jan 2007 15:32:48 -0000	1.34
+++ avr-libc/include/avr/wdt.h	28 Jan 2007 16:29:44 -0000
@@ -128,7 +128,8 @@
 || defined(__AVR_ATmega324P__) \
 || defined(__AVR_ATmega325__) || defined(__AVR_ATmega3250__) \
 || defined(__AVR_ATmega329__) || defined(__AVR_ATmega3290__) \
-|| defined(__AVR_ATmega3290P__) \
+|| defined(__AVR_ATmega325P__) || defined(__AVR_ATmega3250P__) \
+|| defined(__AVR_ATmega329P__) || defined(__AVR_ATmega3290P__) \
 || defined(__AVR_ATmega406__) \
 || defined(__AVR_ATmega640__) \
 || defined(__AVR_ATmega644__) || defined(__AVR_ATmega644P__) \